program syx2ini;

var infile: file of byte;
    outfile: text;

procedure names(title: string; firstnum, lastnum, first, step, length: longint);

var i,j: integer;
    name : string;
    b: byte;

begin
  writeln('Extracting: ', title);
  writeln(outfile, '[', title, ']');
  for i:=firstnum to lastnum do begin
    seek(infile, first + i * step);
    name := '';
    for j:=1 to length do begin
      read(infile, b);
      name := name + chr(b);
    end;
    writeln(outfile, i, '=', name);
    write('.');
  end;
  writeln(outfile, '100=--------------------');
  writeln(outfile);
  writeln;
end;

begin
  writeln('syx2ini: Uli Zukowski, 1.4.95');
  writeln('converts tg500.syx to tg500usr.ini');
  writeln('all sysex dump of tg500 (tg500.syx) must be in current dir');

  assign(infile, 'tg500.syx');
  assign(outfile, 'tg500usr.ini');

  reset(infile);
  rewrite(outfile);

  names('Voice Internal 1', 0, 63, 105, 240, 8);
  names('Voice Internal 2', 0, 63, 15934, 240, 8);

  names('Performance Internal', 0, 63, 31763, 290, 8);

  names('Multi', 0, 15, 50323, 288, 8);

  close(infile);
  close(outfile);
end.